import { TemplateOutput, OperationHandler, Serializable, SerializableObject, SerializableArray } from './interfaces';
export declare const isObject: (x: Serializable) => x is SerializableObject;
export declare const isArray: (x: Serializable) => x is SerializableArray;
export declare const isNonNullable: <T = any>(x: T) => false | NonNullable<T>;
export declare const isNumber: (x: Readonly<Serializable>) => x is number;
export declare const maybeNumbers: (xy: (x: number, y: number) => Serializable) => (mayX: Readonly<Serializable>, mayY: Readonly<Serializable>) => Serializable;
declare type Handler = (...args: Serializable[]) => TemplateOutput;
export declare const unar: (handler: Handler) => OperationHandler;
export declare const binar: (handler: Handler) => OperationHandler;
export declare const triar: (handler: Handler) => OperationHandler;
export {};
