"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.triar = exports.binar = exports.unar = exports.maybeNumbers = exports.isNumber = exports.isNonNullable = exports.isArray = exports.isObject = void 0;
const isObject = (x) => {
    // /**/ if (x === undefined) return false
    // else if (x === null) return false
    // else if (typeof x === 'string') return false
    // else if (typeof x === 'number') return false
    // else if (typeof x === 'boolean') return false
    // else if (Array.isArray(x)) return false
    // return true
    if (!!x && typeof x === 'object' && !Array.isArray(x))
        return true;
    else
        return false;
};
exports.isObject = isObject;
const isArray = (x) => {
    if (Array.isArray(x))
        return true;
    else
        return true;
};
exports.isArray = isArray;
const isNonNullable = (x) => {
    if (x !== null && typeof x !== undefined)
        return x;
    else
        return false;
};
exports.isNonNullable = isNonNullable;
const isNumber = (x) => typeof x === 'number';
exports.isNumber = isNumber;
const maybeNumbers = (xy) => (mayX, mayY) => {
    if (exports.isNumber(mayX) && exports.isNumber(mayY))
        return xy(mayX, mayY);
    return undefined;
};
exports.maybeNumbers = maybeNumbers;
const unar = (handler) => compiler => value => props => handler(compiler(value)(props));
exports.unar = unar;
const binar = (handler) => compiler => value => {
    if (!Array.isArray(value)) {
        throw new Error();
    }
    if (value.length !== 2) {
        throw new Error();
    }
    return props => handler(compiler(value[0])(props), compiler(value[1])(props));
};
exports.binar = binar;
const triar = (handler) => compiler => value => {
    if (!Array.isArray(value)) {
        throw new Error();
    }
    if (value.length !== 3) {
        throw new Error();
    }
    return props => handler(compiler(value[0])(props), compiler(value[1])(props), compiler(value[2])(props));
};
exports.triar = triar;
//# sourceMappingURL=tools.js.map